﻿Imports C1.Win.Chart
Imports System
Imports System.Collections.Generic
Imports System.Drawing
Imports System.Linq
Imports System.Windows.Forms

Namespace FlexChartAxis
    Public Partial Class Form1
        Inherits Form

        Public Sub New()
            InitializeComponent()
            InitChart()
            InitAxisXDataSource()
        End Sub

        Private Sub InitAxisXDataSource()
            flexChart.AxisX.DataSource = New List(Of AxisLabel)() From {
                New AxisLabel() With {
                    .Time = New DateTime(2021, 1, 1, 2, 0, 0),
                    .Text = "02:00"
                },
                New AxisLabel() With {
                    .Time = New DateTime(2021, 1, 1, 5, 0, 0),
                    .Text = "05:00"
                },
                New AxisLabel() With {
                    .Time = New DateTime(2021, 1, 1, 8, 0, 0),
                    .Text = "08:00"
                }
            }
            flexChart.AxisX.Binding = "Time,Text"
        End Sub

        Public Sub InitChart()
            flexChart.Series.Clear()
            flexChart.DataSource = GetData()
            flexChart.BindingX = "Time"
            flexChart.AxisY.Min = 0
            flexChart.AxisY.MajorUnit = 5
            flexChart.AxisY.Max = 40
            Dim series = New Series() With {
                .Binding = "Value",
                .ChartType = C1.Chart.ChartType.LineSymbols,
                .SymbolMarker = C1.Chart.SymbolMarker.Diamond,
                .Name = "Series 1"
            }
            AddHandler series.SymbolRendering, AddressOf OnSymbolRendering
            series.Style.FillColor = Color.Red
            series.Style.StrokeColor = Color.Red
            flexChart.Series.Add(series)
        End Sub

        Public _allowedHours As Integer() = New Integer() {2, 5, 8}

        Private Sub OnSymbolRendering(ByVal sender As Object, ByVal e As RenderSymbolEventArgs)
            Dim dataItem = TryCast(e.Item, DataItem)

            If Not _allowedHours.Any(Function(x) dataItem.Time.Hour = x) Then
                e.Cancel = True
            End If
        End Sub

        Public Iterator Function GetData() As IEnumerable(Of DataItem)
            For hour = 0 To 10
                Yield New DataItem() With {
                    .Time = New DateTime(2021, 1, 1, hour, 0, 0),
                    .Value = 10
                }
            Next
        End Function
    End Class

    Public Class AxisLabel
        Public Property Text As String
        Public Property Time As Date
    End Class

    Public Class DataItem
        Public Property Time As Date
        Public Property Value As Double
    End Class
End Namespace
